$!
$! Script to handle generation of SSL keys and certificate requests.
$!
$ net_write = "write net_link/error=abort"
$ net_write "<DNETRECMODE>"
$ on error then goto abort
$ cgi_symbols WWW_ FORM_
$ if f$length(FORM_FIELDS) .le. 0
$ then
$!	No content, Redirect to form.
$    net_write "Location: /demo/ssl_certificate.html"
$    net_write ""
$    exit
$ endif
$!
$! Setup SSL environment
$!
$ if f$search("WWW_ROOT:[000000]SSL_SETUP.COM") .eqs. ""
$ then
$    create net_link:
Content-Type: text/html

<HTML><TITLE>Certificate generate error</TITLE></HTML><BODY>
Missing www_root:[000000]SSL_SETUP.COM, script cannot operate.
<P>
The ssl_setup.com procedure defines the ssleay symbol to invoke images
in the ssleay [.apps] directory (SSLEAY == "disk:[dir.APPS]'") and
defines the ssleay_conf logical to point to the ssleay configuration file
(ssleay.cnf).
</BODY></HTML>
$ exit
$ endif
$ @www_root:[000000]ssl_setup
$!
$ net_write "content-type: text/plain", f$fao("!/")
$ key_file = "''FORM_FLD_KEYFILE'"
$ key_size = f$integer("0''FORM_FLD_KEYSIZE'")
$ key_create = "''FORM_FLD_KEYCREATE'"
$ key_file_spec = f$parse("SYS$LOGIN:.KEY",key_file,"SSL_SERVER")
$ if f$search(key_file_spec) .eqs. ""
$ then
$    if ( key_size .eq. 0 ) key_size = 1024
$    if f$edit(key_create,"UPCASE") .nes. "ON"
$    then
$	net_write "Cannot find key file ", key_file_spec, " aborting."
$	exit
$    endif
$    net_write "Creating new key file (no pass phrase), size=", key_size, "..."
$    sho system/full/out=sys$Login:shosys.tmp
$    ssleay genrsa -rand sys$login:shosys.tmp -out 'key_file_spec' 'key_size'
$    net_write "   key file created, please safegard and backup this file"
$    net_write ""
$ else
$    net_write "Using existing key file...",f$fao("!/")
$ endif
$!
$ inp_file = f$parse("sys$login:.inp",key_file_spec)
$ create 'inp_file'
$ open/append ifile 'inp_file'
$ on error then goto cleanup
$ write ifile "''form_fld_dn_country'"
$ write ifile "''form_fld_dn_state'"
$ write ifile "''form_fld_dn_city'"
$ write ifile "''form_fld_dn_org'"
$ write ifile "''form_fld_dn_dept'"
$ write ifile "''form_fld_dn_common'"
$ write ifile "''form_fld_dn_contact'"
$ write ifile "''form_fld_csr_pwd'"
$ write ifile "''form_fld_csr_company'"
$!
$ cleanup:
$ close ifile
$ if f$edit("''form_fld_csrfile'","TRIM") .nes. ""
$ then
$    csr_file_spec = f$parse("SYS$LOGIN:.CSR",form_fld_csrfile)
$    define/user sys$input 'inp_file'
$     ssleay req -new -key 'key_file_spec' -out 'csr_file_spec'
$     net_write "Created Certificate Request file ''csr_file_spec':"
$     copy 'csr_file_spec' net_link:
$    net_write ""
$ endif
$!
$ if "''form_fld_sscfile'" .nes. ""
$ then
$    ssc_file_spec = f$parse(".SSC",form_fld_sscfile)
$    define/user sys$input 'inp_file'
$     ssleay req -new -x509 -key 'key_file_spec' -in 'inp_file' -out 'ssc_file_spec'
$     net_write "Created self-signed certificate ''ssc_file_spec':"
$     copy 'ssc_file_spec' net_link:
$     net_write ""
$     net_write "Append to key file for use by server"
$ endif
$ abort:
$ exit
