$! INSTALL.COM -- Installs relevant files in a given directory tree
$!
$! Author: Richard Levitte <richard@levitte.org>
$! Time of creation: 27-MAR-1999 12:55
$!
$! P1	root of directory tree
$!
$	IF P1 .EQS. ""
$	THEN
$	    WRITE SYS$OUTPUT "First argument missing."
$	    WRITE SYS$OUTPUT "Should be the directory where you want things installed."
$	    EXIT
$	ENDIF
$
$	ARCH = "AXP"
$	IF F$GETSYI("CPU") .LT. 128 THEN ARCH = "VAX"
$
$	ROOT = F$PARSE(P1,"[]A.;0",,,"SYNTAX_ONLY,NO_CONCEAL") - "A.;0"
$	ROOT_DEV = F$PARSE(ROOT,,,"DEVICE","SYNTAX_ONLY")
$	ROOT_DIR = F$PARSE(ROOT,,,"DIRECTORY","SYNTAX_ONLY") -
		   - ".][000000" - "[000000." - "][" - "[" - "]"
$	ROOT = ROOT_DEV + "[" + ROOT_DIR
$
$	! The following is a twisted way to guarantee we'll get [] as
$	! directory delimiters...
$	HERE = F$PARSE("A.",F$ELEMENT(0,";",F$ENV("PROCEDURE")),"[]") - "]A.;"
$
$	COPY := COPY/LOG
$
$	! Install files in the root directory
$	D_FROM := 'HERE']
$	D_TO := 'ROOT]
$	F_COPYALWAYS := *.COM
$	F_IFNOTEXIST := ACCESSES.PERMISSIONS
$	GOSUB INSTALL_FILES
$	D_FROM := 'HERE'.BASE_CODE]
$	D_TO := 'ROOT]
$	F_COPYALWAYS := WWWSSL.COM
$	F_IFNOTEXIST := 
$	GOSUB INSTALL_FILES
$
$	! Install files in the [.SYSTEM] directory
$	D_FROM := 'HERE'.SYSTEM]
$	D_TO := 'ROOT'.SYSTEM]
$	F_COPYALWAYS := *.*/EXCLUDE=(*.DIR)
$	F_IFNOTEXIST :=
$	GOSUB INSTALL_FILES
$
$	! Install files in the [.BIN] directory
$	D_FROM := 'HERE'.BIN]
$	D_TO := 'ROOT'.BIN]
$	F_COPYALWAYS := *.*/EXCLUDE=(*.DIR)
$	F_IFNOTEXIST :=
$	GOSUB INSTALL_FILES
$
$	! Install files in the [.CGI-BIN] directory
$	D_FROM := 'HERE'.CGI-BIN]
$	D_TO := 'ROOT'.CGI-BIN]
$	F_COPYALWAYS := *.*/EXCLUDE=(*.DIR)
$	F_IFNOTEXIST :=
$	GOSUB INSTALL_FILES
$
$	! Install files in the [.SERVERDOC] directory
$	D_FROM := 'HERE'.SERVERDOC]
$	D_TO := 'ROOT'.SERVERDOC]
$	F_COPYALWAYS := *.*/EXCLUDE=(*.DIR)
$	F_IFNOTEXIST :=
$	GOSUB INSTALL_FILES
$
$	! Install files in the [.SCRIPT_CODE] directory
$	D_FROM := 'HERE'.SCRIPT_CODE]
$	D_TO := 'ROOT'.SCRIPT_CODE]
$	F_COPYALWAYS := *lib.obj,*lib.h
$	F_IFNOTEXIST :=
$	GOSUB INSTALL_FILES
$
$
$	EXIT
$
$ INSTALL_FILES:
$	IF F$PARSE(D_TO) .EQS. "" THEN CREATE/DIR 'D_TO'
$	I = 0
$ LOOP_ALWAYS:
$	E = F$ELEMENT(I,",",F_COPYALWAYS)
$	I = I + 1
$	IF E .EQS. "," THEN GOTO LOOP_ALWAYS_END
$	IF E .EQS. "" THEN GOTO LOOP_ALWAYS
$	COPY 'D_FROM''E' 'D_TO'
$	GOTO LOOP_ALWAYS
$ LOOP_ALWAYS_END:
$	I = 0
$ LOOP_MAYBE:
$	E = F$ELEMENT(I,",",F_IFNOTEXIST)
$	I = I + 1
$	IF E .EQS. "," THEN GOTO LOOP_MAYBE_END
$	IF E .EQS. "" THEN GOTO LOOP_MAYBE
$	IF F$SEARCH("''D_TO'''E'") .NES. "" THEN GOTO LOOP_MAYBE
$	COPY 'D_FROM''E' 'D_TO'
$	GOTO LOOP_MAYBE
$ LOOP_MAYBE_END:
$	RETURN
